Unit QS60R_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, UTQS10_p;

procedure QS60R(var INT :Real; var A1 :Array of Real;
                var A2 :Array of Real; F :Func_F1A; EPS :Real;
                var IERR :Integer);

implementation

procedure QS60R(var INT :Real; var A1 :Array of Real;
                var A2 :Array of Real; F :Func_F1A; EPS :Real;
                var IERR :Integer);
var
I,K,L :Integer;
H,H1,S1,S2,R1,R2 :Real;
R :Array [0..23] of Integer;
C :Array [0..2] of Real;
X :Array [0..2] of Real;
Z :Array [0..2] of Real;
D :Array [0..2] of Real;
B :Array [0..10] of Real;
GR :Array [0..43] of Real;
T :Array [0..32] of Real;
const
EDMA2 :Real = 3.292722E-10;
label
_1,_2,_3,_4,_5,_6,_7,_8,_9,_10,_11,_12,_13,_14,_15;
begin
{   DATA  FORTRAN  }
R[0] := 0;
R[1] := 0;
R[2] := 0;
R[3] := -1;
R[4] := 0;
R[5] := 0;
R[6] := 0;
R[7] := 1;
R[8] := 0;
R[9] := -1;
R[10] := 0;
R[11] := 1;
R[12] := 0;
R[13] := -1;
R[14] := 0;
R[15] := 1;
R[16] := -1;
R[17] := 1;
R[18] := -1;
R[19] := 1;
R[20] := -1;
R[21] := 1;
R[22] := -1;
R[23] := 1;
B[0] := 0.674199;
B[1] := 0.597614;
B[2] := 0.195555;
B[3] := 0.067222;
B[4] := 0.044444;
B[5] := -1.410909;
B[6] := 0.034955;
B[7] := 0.139377;
B[8] := 0.013333;
B[9] := 0.444444;
B[10] := 0.555555;
GR[0] := 0.0;
GR[1] := 1.0;
GR[2] := 0.0;
GR[3] := -1.0;
GR[4] := 0.0;
GR[5] := 0.0;
GR[6] := 1.0;
GR[7] := 0.0;
GR[8] := -1.0;
GR[9] := 1.0;
GR[10] := 0.0;
GR[11] := 1.0;
GR[12] := -1.0;
GR[13] := 0.0;
GR[14] := -1.0;
GR[15] := -1.0;
GR[16] := 0.0;
GR[17] := 1.0;
GR[18] := 1.0;
GR[19] := 0.0;
GR[20] := 0.0;
GR[21] := 1.0;
GR[22] := 0.0;
GR[23] := 0.0;
GR[24] := -1.0;
GR[25] := 0.0;
GR[26] := 1.0;
GR[27] := -1.0;
GR[28] := 1.0;
GR[29] := 1.0;
GR[30] := 1.0;
GR[31] := -1.0;
GR[32] := -1.0;
GR[33] := -1.0;
GR[34] := 1.0;
GR[35] := -1.0;
GR[36] := 0.0;
GR[37] := 0.0;
GR[38] := 0.0;
GR[39] := 1.0;
GR[40] := 0.0;
GR[41] := 0.0;
GR[42] := 0.0;
GR[43] := -1.0;
D[0] := (A2[0]-A1[0])*(A2[1]-A1[1])*(A2[2]-A1[2]);
D[1] := EDMA2;
D[2] := 1.0;
IERR := 0;
INT := 0.0;
L := 1;
H := 0.5;
K := 0;
C[0] := 0.75;
C[1] := 0.75;
C[2] := 0.75;
goto _7;
_1:
H := H/2.0;
if ( H-D[1] ) < 0
 then goto _2
 else if ( H-D[1] ) > 0
       then goto _3
       else goto _3;
_2:
IERR := 65;
goto _4;
_3:
T[L-1] := K;
L := L+1;
K := 0;
H1 := H/2.0;
C[0] := C[0]+H1*R[7];
C[1] := C[1]+H1*R[15];
C[2] := C[2]+H1*R[23];
goto _7;
_4:
C[0] := C[0]+H*R[(K+1-1)+0];
C[1] := C[1]+H*R[(K+1-1)+8];
C[2] := C[2]+H*R[(K+1-1)+16];
K := K+1;
if ( K-8 ) < 0
 then goto _7
 else if ( K-8 ) > 0
       then goto _7
       else goto _5;
_5:
if ( L-1 ) < 0
 then goto _6
 else if ( L-1 ) > 0
       then goto _6
       else goto _15;
_6:
L := L-1;
H1 := H/2.0;
C[0] := C[0]-H1*R[7];
C[1] := C[1]-H1*R[15];
C[2] := C[2]-H1*R[23];
H := 2.0*H;
K := Trunc( T[L-1] );
goto _4;
_7:
for I:=1 to 3 do
 begin
  X[I-1] := C[I-1];
  Z[I-1] := A2[I-1]-A1[I-1];
  X[I-1] := Z[I-1]*X[I-1]+A1[I-1];
_8:
 end;
S1 := B[2]*F(X);
S2 := S1*B[5];
R2 := 0.0;
R1 := B[0]*H/2.0;
for I:=1 to 8 do
 begin
  X[0] := C[0]+R1*GR[26+I-1];
  X[0] := Z[0]*X[0]+A1[0];
  X[1] := C[1]+R1*GR[27+I-1];
  X[1] := Z[1]*X[1]+A1[1];
  X[2] := C[2]+R1*GR[28+I-1];
  X[2] := Z[2]*X[2]+A1[2];
  R2 := R2+F(X);
_9:
 end;
S1 := S1+B[3]*R2;
S2 := S2+B[6]*R2;
R2 := 0.0;
R1 := H/2.0;
for I:=1 to 6 do
 begin
  X[0] := C[0]+R1*GR[I-1];
  X[0] := Z[0]*X[0]+A1[0];
  X[1] := C[1]+R1*GR[I+18];
  X[1] := Z[1]*X[1]+A1[1];
  X[2] := C[2]+R1*GR[I+34];
  X[2] := Z[2]*X[2]+A1[2];
  R2 := R2+F(X);
_10:
 end;
S1 := S1+B[4]*R2;
R2 := 0.0;
R1 := B[1]*H/2.0;
for I:=1 to 6 do
 begin
  X[0] := C[0]+R1*GR[I-1];
  X[0] := Z[0]*X[0]+A1[0];
  X[1] := C[1]+R1*GR[I+18];
  X[1] := Z[1]*X[1]+A1[1];
  X[2] := C[2]+R1*GR[I+34];
  X[2] := Z[2]*X[2]+A1[2];
  R2 := R2+F(X);
_11:
 end;
S2 := S2+B[7]*R2;
R2 := 0.0;
R1 := H/2.0;
for I:=1 to 12 do
 begin
  X[0] := C[0]+R1*GR[I+5];
  X[0] := Z[0]*X[0]+A1[0];
  X[1] := C[1]+R1*GR[I+6];
  X[1] := Z[1]*X[1]+A1[1];
  X[2] := C[2]+R1*GR[I+7];
  X[2] := Z[2]*X[2]+A1[2];
  R2 := R2+F(X);
_12:
 end;
S2 := S2+B[8]*R2;
S1 := S1*D[0]*IntPower(H,3);
S2 := S2*D[0]*IntPower(H,3);
if ( Abs(S1-S2)-EPS ) < 0
 then goto _13
 else if ( Abs(S1-S2)-EPS ) > 0
       then goto _14
       else goto _13;
_13:
INT := INT+B[9]*S1+B[10]*S2;
goto _4;
_14:
goto _1;
_15:
if ( IERR  <> 0 ) 
 then UTQS10(IERR,6);
end;

end.
